function MiraMod_AddInstance(name, initFunction)
		
	entry = {};
	entry["active"] 								= false;
	entry["initFunc"]								= initFunction;
	MiraModInstances[MiraMod_GetTranslation(name)] 	= entry;
	
end

function MiraMod_AddDebuff(name, addSound, addTextMsg, removeSound, removeMsg, scanInGroup, addYell, removeYell, stackCount, tiggerCountdown, countDown)

	local entry = {};
												
	if(scanInGroup == nil) then
		scanInGroup = false;
	end
	
	if(stackCount == nil) then
		stackCount = 0;
	end
	
	if(tiggerCountdown == nil) then
		tiggerCountdown = false;
	end
	
	if(countDown == nil) then
		countDown = 0;
	end
	
	entry["state"]			= false;
	entry["countdownPos"]	= 0;
												
	entry["name"] 			= MiraMod_GetTranslation(name);
	entry["addSound"]		= addSound;
	entry["addMsg"]			= MiraMod_GetTranslation(addTextMsg);
	entry["removeSound"]	= removeSound;
	entry["removeMsg"]		= MiraMod_GetTranslation(removeMsg);
	entry["scanInGroup"]	= scanInGroup;
	entry["addYell"]		= MiraMod_GetTranslation(addYell);
	entry["removeYell"]		= MiraMod_GetTranslation(removeYell);
	entry["stackCount"]		= stackCount;
	entry["triggersCount"]	= tiggerCountdown;
	entry["countdown"]		= countDown;
		
	table.insert(MiraModDebuffs, entry);

end

function MiraMod_AddCombat(source, actionType, spellId, spellName, sound, textMsg, func, stackCount, target)
											
	local entry = {};
	
	if(stackCount == nil) then
		stackCount = 0;
	end
	
	entry["source"] 	= MiraMod_GetTranslation(source);
	entry["actionType"]	= actionType;
	entry["spellId"] 	= spellId;
	entry["spellName"] 	= MiraMod_GetTranslation(spellName);
	entry["sound"]		= sound;
	entry["textMsg"] 	= MiraMod_GetTranslation(textMsg);
	entry["func"] 		= func;
	entry["stackCount"] = stackCount;
	entry["target"] 	= MiraMod_GetTranslation(target);

	table.insert(MiraModCombat, entry);
	
end

function MiraMod_AddSpecialTimer(EndTime, Msg, Snd, Function, Name)

	local entry = {};
	entry["endTime"] = tonumber(EndTime);
	entry["msg"]	 = Msg;
	entry["snd"]	 = Snd;
	entry["func"]	 = Function;
	entry["name"]	 = Name;
	table.insert(MiraModTimers, entry);
		
end

function MiraMod_CancelSpecialTimer(Name)

	for za=TimerSize,1,-1 do
			
		local entry   = MiraModTimers[za];
		
		if(entry["name"] ~= nil) then
		
			if(entry["name"] == Name) then
			
				table.remove(MiraModTimers, za);
				return;
			
			end
		
		end
		
	end

end

function MiraMod_AddYellCheckFunction(yellFunc)

	table.insert(MiraModYellCheckFunctions, yellFunc);

end

function MiraMod_AddRaidTargetUpdateFunction(raidFunc)

	table.insert(MiraModRaidTargetFunctions, raidFunc);

end

function MiraMod_AddEncounterStartFunction(encounterFunc)

	table.insert(MiraModEncounterStartFunctions, encounterFunc);
	
end